"use strict";

var _require = require("./util");

var isGlobal = _require.isGlobal;
var isResolved = _require.isResolved;
var existsAndIsFile = _require.existsAndIsFile;
var debug = require("debug")("yoloader:resolve:file");
var _require2 = require("../f");

var catcher = _require2.catcher;
var path = require("path");

/**
 * Tries to resolve a dependency as a file
 */
module.exports = function resolveFile(dep, opts, cb) {
	if (isGlobal(dep.to) || isResolved(dep)) {
		return cb(null, dep);
	}
	debug("Trying to resolve " + dep.to + " from " + dep.from + " as a file");
	var file = path.resolve(path.dirname(dep.from), dep.to);
	var onSuccess = catcher(cb);
	existsAndIsFile(file, onSuccess(function (found) {
		if (found) {
			debug("Resolved " + dep.to + " from " + dep.from + " as " + file);
			dep.file = file;
			dep.base = opts.base;
		}
		cb(null, dep);
	}));
};