"use strict";

var through = require("through2");
/**
 * Renames a file before including it in the bundle.
 */
module.exports = function rename(yoloader, renames) {
	yoloader.bundlePipeline.unshift(function (instance, bundleOpts) {
		return through.obj(function (chunk, enc, done) {
			var renameKey = Object.keys(renames).find(function (key) {
				if (key.endsWith("*")) {
					key = key.slice(0, -1);
					return chunk.path.startsWith(key);
				} else {
					return chunk.path === key;
				}
				return chunk.path.startsWith(key);
			});
			if (renameKey) {
				if (renameKey.endsWith("*")) {
					chunk.name = chunk.path.replace(renameKey.slice(0, -1), renames[renameKey]);
				} else {
					chunk.name = renames[renameKey];
				}
			}
			done(null, chunk);
		});
	});
};