"use strict";

//Very simple ad hoc profiling implementation. I couldn't find any good non-continuous profiling
//libraries in a couple of minutes, so writing my own is faster here. (suggestions for better frameworks
//are welcome!)
var startTimer = function () {
	return { stop: function stop() {} };
};
var printTimings = function () {};
if (process.env.YOLOADER_PROFILE) {
	(function () {
		var totalTimings = {};
		startTimer = function (name) {
			var start = new Date().getTime();
			return {
				stop: function stop() {
					var now = new Date().getTime();
					if (!start) {
						console.error("timer was already stopped");
					} else {
						var totalTiming = totalTimings[name] || { time: 0, calls: 0 };
						totalTiming.time += now - start;
						totalTiming.calls++;
						totalTimings[name] = totalTiming;
						start = null;
					}
				}
			};
		};
		printTimings = function () {
			console.log(totalTimings);
		};
	})();
}

module.exports = { startTimer: startTimer, printTimings: printTimings };